
#ifndef PLATFORMSSL_H
#define PLATFORMSSL_H

namespace LibPlatform {
	class SSL {
	public:
		typedef enum {
			SSL_SSLVERSION_INVALID = -1,

			/* Automatically select the highest version supported out of TLS1.0/SSLv3 */
			SSL_SSLVERSION_AUTO,

			/* TLS 1.0 */
			SSL_SSLVERSION_TLSv1,

			/* SSLv3 */
			SSL_SSLVERSION_SSLv3
		} SSLSSLVersion;

		typedef enum {
		   SSL_CERT_TYPE_DER
		} SSLCertType;

		typedef signed SSLContextHandle;

		static signed Init(void);
		static signed CreateContext(SSLSSLVersion ssl_version);
		static signed DestroyContext(signed context);
		static signed AddServerPKIExternal(
			SSLContextHandle context,
			const unsigned char *pServerCert, 
			int serverCertLen,
			SSLCertType serverCertType
		);
	};
}

#endif//PLATFORMSSL_H
