/*---------------------------------------------------------------------------*

  Copyright 2012 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

 *---------------------------------------------------------------------------*/

#ifndef UNISTD_H_
#define UNISTD_H_

#include "sys/time.h"
#include "sys/types.h"

#ifdef __cplusplus
extern "C" {
#endif

/* for access */
#define R_OK 4
#define W_OK 2 
#define X_OK 1
#define F_OK 0 

/* for lseek */
#define SEEK_SET 0 
#define SEEK_CUR 1 
#define SEEK_END 2

int access(char *name, int type);
int close(int fd);
int fsync(int fd);
int ftruncate(int fd, off_t length);
char *getcwd(char *buf, size_t size);
off_t lseek(int fd, off_t offset, int whence);
int read(int fd, void *buf, size_t n);
unsigned int sleep(unsigned int seconds);
int usleep(unsigned long us);
int rmdir(const char *path);
int rmdir_recursive(const char *path);
int unlink(const char *path);
int write(int fd, void *buf, size_t n);

int getpid();

#ifdef __cplusplus
}
#endif

#endif
