/*

	Thread Control Code
	
	Support code for FG/BG switching etc.

	INCLUDE

	THIS EXPOSES WII U SDK COMPONENTS: use only in modules where this is allowable!

*/

#ifndef _THREAD_CTRL_WIIU_H_
#define _THREAD_CTRL_WIIU_H_

#ifdef __cplusplus
extern "C" {
#endif

signed shim_CreateThread(void* thread, int (*entryPoint)(int, void *), int intArg, void* ptrArg, void* stack, unsigned stackSize, signed priority, unsigned short attr);

void shim_ThreadDone(void);

void _shim_threadCtrl_Startup(void);
void _shim_threadCtrl_Shutdown(void);

#define	SHIM_SWITCH_NONE		0
#define	SHIM_SWITCH_TO_BG		1
#define	SHIM_SWITCH_TO_FG		2
#define	SHIM_SWITCH_SHUTDOWN	3

int shim_RegisterSyncThread(void *pThread, int (*abortCB)(void *pUser), void *pUser);
void shim_UnregisterSyncThread(void *pThread);

unsigned shim_PollForSwitch(void);
void shim_AcknowledgeSwitch(void);

// vvv DEPRECIATED, DO NOT USE - left in here for now to support MobiClip media player
void shim_WaitForForeground(void);
// ^^^ DEPRECIATED, DO NOT USE - left in here for now to support MobiClip media player

#define	SHIM_SWITCHTARGET_HBM		0		// Bring up HBM
#define	SHIM_SWITCHTARGET_SETTINGS	1		// Launch Settings
#define	SHIM_SWITCHTARGET_ACCOUNT	2		// Launch Account Management
#define	SHIM_SWITCHTARGET_MENU		3		// Launch menu and quit app
#define	SHIM_SWITCHTARGET_BROWSER	4		// Bring up Browser
#define	SHIM_SWITCHTARGET_SELF		5		// Restart app

void shim_RequestProcessSwitch(int target, const void *pParam0, const void *pParam1);

void shim_RegisterExitMessageCallback(void (*callback)(void));

int shim_IsBackground(void);
int shim_HaveThreadsBeenMoved();
void shim_SetHaveThreadsBeenMoved(int b);

void shim_EnableHBM(signed enable);
signed shim_WasHBMDenied(void);
void shim_ResetHBMDenied(void);

// For 'dirty' shutdown. Should only be
// used if we're in a state of non-recovery.
// Basically we've run out of memory
// and we're failing an allocation.
void shim_LetMasterThreadDrop(void);

// We need to be able to shutdown all threads that are not related to the application launcher.
// Because of this the notion of a 'strong' and 'weak' thread is made up.
// All threads by default are 'weak'.

// Will attempt to properly shutdown all weak threads.
// If proper shutdown fails, this function will attempt to kill the thread.
void shim_stopWeakThreads(void);

// Calling this within a thread will guarantee that the calling thread will not be shutdown via a call to shim_stopWeakThreads.
void shim_registerStrongThread(void);

#ifdef __cplusplus
} // extern "C"
#endif

#endif // _THREAD_CTRL_WIIU_H_
